import Entity from '../../Entity';
import { Image } from '../image';
import { Track } from '../track';
export default class Playlist extends Entity {
    readonly id: string;
    readonly name: string;
    readonly description: string;
    readonly icon?: Image;
    readonly backgroundImage: Image;
    readonly tracks: Track[];
    static deserialize(playlistJson: Record<string, unknown>): Playlist;
}
