import Entity from '../../Entity';
import { Album } from '../album';
import { Artist } from '../artist';
export default class Track extends Entity {
    readonly id: string;
    readonly href: string;
    readonly name: string;
    readonly previewUrl: string;
    readonly album: Album;
    readonly artists: Artist[];
    readonly durationMs: number;
    static deserialize(trackJson: Record<string, unknown>): Track;
}
