"use strict";
var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (Object.prototype.hasOwnProperty.call(b, p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        if (typeof b !== "function" && b !== null)
            throw new TypeError("Class extends value " + String(b) + " is not a constructor or null");
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
var __metadata = (this && this.__metadata) || function (k, v) {
    if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(k, v);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
var index_1 = require("../../../../index");
var Entity_1 = __importDefault(require("../../Entity"));
var album_1 = require("../album");
var Track = (function (_super) {
    __extends(Track, _super);
    function Track() {
        return _super !== null && _super.apply(this, arguments) || this;
    }
    Track.deserialize = function (trackJson) {
        return index_1.deserialize(trackJson, Track);
    };
    __decorate([
        index_1.JsonProperty({ path: 'track.id', required: true }),
        __metadata("design:type", String)
    ], Track.prototype, "id", void 0);
    __decorate([
        index_1.JsonProperty({ path: 'track.href', required: true }),
        __metadata("design:type", String)
    ], Track.prototype, "href", void 0);
    __decorate([
        index_1.JsonProperty({ path: 'track.name', required: true }),
        __metadata("design:type", String)
    ], Track.prototype, "name", void 0);
    __decorate([
        index_1.JsonProperty({ path: 'track.preview_url', required: true }),
        __metadata("design:type", String)
    ], Track.prototype, "previewUrl", void 0);
    __decorate([
        index_1.JsonProperty({ path: 'track.album', required: true }),
        __metadata("design:type", album_1.Album)
    ], Track.prototype, "album", void 0);
    __decorate([
        index_1.JsonProperty({ path: 'track.artists', required: true }),
        __metadata("design:type", Array)
    ], Track.prototype, "artists", void 0);
    __decorate([
        index_1.JsonProperty({ path: 'track.duration_ms', required: true }),
        __metadata("design:type", Number)
    ], Track.prototype, "durationMs", void 0);
    return Track;
}(Entity_1.default));
exports.default = Track;
