"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
require("reflect-metadata");
var common_1 = require("./common");
function JsonProperty(arg) {
    if (arg === void 0) { arg = {}; }
    return function (object, propertyName) {
        var params = typeof arg !== 'string'
            ? arg
            : {
                path: arg,
            };
        var type = params.type || Reflect.getMetadata('design:type', object, propertyName);
        var commonMetadata = Reflect.getMetadata(common_1.ReflectMetaDataKeys.TsJacksonJsonProperty, object.constructor) || {};
        commonMetadata[propertyName] = __assign({ type: type, name: propertyName, path: propertyName }, params);
        Reflect.defineMetadata(common_1.ReflectMetaDataKeys.TsJacksonJsonProperty, commonMetadata, object.constructor);
    };
}
exports.default = JsonProperty;
