import Entity from '../../Entity';
import { Image } from '../image';
export default class PlaylistPreview extends Entity {
    readonly id: string;
    readonly name: string;
    readonly description: string;
    readonly backgroundImage: Image;
    readonly href: string;
    readonly tracks: {
        href: string;
        total: number;
    };
    static deserialize(playlistPreviewJson: Record<string, unknown>): PlaylistPreview;
}
